// src/devcenter-bi-events-v1-send-bi-event-response-bi-events.universal.ts
import { transformError as sdkTransformError } from "@wix/sdk-runtime/transform-error";
import { renameKeysFromSDKRequestToRESTRequest } from "@wix/sdk-runtime/rename-all-nested-keys";

// src/devcenter-bi-events-v1-send-bi-event-response-bi-events.http.ts
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveComWixpressMarketAimApiBiEventsServiceUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/app-instance-manager-webapp",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "dev._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      },
      {
        srcPath: "/api/v1/instance",
        destPath: "/v1/instance"
      },
      {
        srcPath: "/api/v1/scripts",
        destPath: "/v1/scripts"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_app-management_bi-events";
function sendBiEvent(payload) {
  function __sendBiEvent({ host }) {
    const metadata = {
      entityFqdn: "wix.devcenter.bi_events.v1.send_bi_event_response",
      method: "POST",
      methodFqn: "com.wixpress.market.aim.api.BIEventsService.sendBIEvent",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiBiEventsServiceUrl({
        protoPath: "/v1/bi-event",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __sendBiEvent;
}

// src/devcenter-bi-events-v1-send-bi-event-response-bi-events.universal.ts
var EventName = /* @__PURE__ */ ((EventName2) => {
  EventName2["UNKNOWN"] = "UNKNOWN";
  EventName2["APP_DASHBOARD_LOADED"] = "APP_DASHBOARD_LOADED";
  EventName2["APP_FINISHED_CONFIGURATION"] = "APP_FINISHED_CONFIGURATION";
  EventName2["APP_UPGRADED"] = "APP_UPGRADED";
  EventName2["PRIMARY_ACTION_PERFORMED"] = "PRIMARY_ACTION_PERFORMED";
  EventName2["CUSTOM"] = "CUSTOM";
  EventName2["CHARGE"] = "CHARGE";
  EventName2["FUNDS_RETURNED"] = "FUNDS_RETURNED";
  EventName2["APP_FINISH_BUSINESS_SETUP"] = "APP_FINISH_BUSINESS_SETUP";
  EventName2["APP_DEPLOYED"] = "APP_DEPLOYED";
  EventName2["APP_SETUP_FINISHED"] = "APP_SETUP_FINISHED";
  return EventName2;
})(EventName || {});
async function sendBiEvent2(options) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = renameKeysFromSDKRequestToRESTRequest({
    eventName: options?.eventName,
    customEventName: options?.customEventName,
    eventData: options?.eventData
  });
  const reqOpts = sendBiEvent(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
  } catch (err) {
    const transformedError = sdkTransformError(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          eventName: "$[0].eventName",
          customEventName: "$[0].customEventName",
          eventData: "$[0].eventData"
        },
        singleArgumentUnchanged: false
      },
      ["options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/devcenter-bi-events-v1-send-bi-event-response-bi-events.public.ts
function sendBiEvent3(httpClient) {
  return (options) => sendBiEvent2(
    options,
    // @ts-ignore
    { httpClient }
  );
}

// src/devcenter-bi-events-v1-send-bi-event-response-bi-events.context.ts
import { createRESTModule } from "@wix/sdk-runtime/rest-modules";
var sendBiEvent4 = /* @__PURE__ */ createRESTModule(sendBiEvent3);
export {
  EventName,
  sendBiEvent4 as sendBiEvent
};
//# sourceMappingURL=index.mjs.map